#include <fggl/gui/containers.hpp>

namespace fggl::gui {

	Box::Box( LayoutAxis axis ) : m_axis( axis ) {}
	
	void Box::layout() {
		math::vec2 baseSize{};
		
		const int mainAxis = 0;
		const int crossAxis = 1;
		
		// ask for preferred sizes
		for ( auto& child : m_children ) {
			auto childBaseSize = child.baseSize();
			
			baseSize[mainAxis] += childBaseSize[mainAxis];
			if ( childBaseSize[crossAxis] > baseSize[crossAxis] ) {
				baseSize[crossAxis] = childBaseSize[crossAxis];			
			}
		}
		
		if ( lineAxis == 0 )
			setSize(lineSum, biggestCross);
		else
			setSize(biggestCross, lineSum);
	}

};
