#ifndef FGGL_GUI_WIDGET_H
#define FGGL_GUI_WIDGET_H

#include <fggl/math/types.hpp>
#include <fggl/gfx/paint.hpp>

namespace fggl::gui {

	class Widget {
		public:
			Widget() = default;

			virtual bool contains(const math::vec2 &point);
			virtual Widget *getChildAt(const math::vec2 &point);

			virtual void render(gfx::Paint &paint) = 0;
	};

	class Container : public Widget {
		public:
			Container() = default;

			void clear();
			Widget *getChildAt(const std::math &point) override;

			void add(Widget &&widget);

		private:
			bool requireLayout;
			std::vector<std::unique_ptr<Widget>> m_children;
	};

}; //namespace fggl::gui

#endif
